=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-11-22 00:21:46 +0000
+++ viz/branchwin.py	2007-11-22 00:56:23 +0000
@@ -291,7 +291,7 @@
         self.toolbar.insert(gtk.SeparatorToolItem(), -1)
 
         refresh_button = gtk.ToolButton(gtk.STOCK_REFRESH)
-        refresh_button.connect('clicked', lambda x: self.treeview.refresh())
+        refresh_button.connect('clicked', self._refresh_clicked)
         self.toolbar.insert(refresh_button, -1)
 
         self.toolbar.show_all()
@@ -435,3 +435,6 @@
         dialog = AboutDialog()
         dialog.connect('response', lambda d,r: d.destroy())
         dialog.run()
+
+    def _refresh_clicked(self, w):
+        self.treeview.update()

=== modified file 'viz/treeview.py'
--- viz/treeview.py	2007-11-22 00:36:32 +0000
+++ viz/treeview.py	2007-11-22 00:56:23 +0000
@@ -171,6 +171,17 @@
     def refresh(self):
         gobject.idle_add(self.populate, self.get_revision())
 
+    def update(self):
+        try:
+            self.branch.unlock()
+            try:
+                self.branch.lock_write()
+                self.branch.update()
+            finally:
+                self.branch.unlock()
+        finally:
+            self.branch.lock_read()
+
     def back(self):
         """Signal handler for the Back button."""
         parents = self.get_parents()

